import { c as J, a as K, t as Q, z as j, p as $, V as q, O as R, f as U, L as ee, G as te, i as ie, a2 as re, a0 as ae, a3 as le, v as se, a4 as ne, d as he, B as oe, b as ce, q as de, R as ue, a5 as ge, r as fe, e as Ie, y as Ne, C as me, x as xe, a6 as be, Y as Fe, o as _e, s as Ae, w as ye, F as Le, A as Ce, u as Se } from "./index-DhxnZ6ZS.js";
import { D as ke } from "./DataTable-jvL0XGWl.js";
import { _ as we } from "./Title-DLo3Zo2_.js";
import { _ as Oe, u as Ge } from "./Tooltip-CA1QhFeE.js";
import { U as ve } from "./usePrinter-mDGfOQZA.js";
import { _ as pe } from "./Shape-Rg6yW7m3.js";
import ze from "./BaseIcon-CiQzR1fE.js";
import Me from "./vue-ui-table-sparkline-BUNsAEVY.js";
import Te from "./vue-ui-skeleton-pdtGfiV6.js";
import { S as Pe } from "./Slicer-CP2Z31Lc.js";
import Ve from "./vue-ui-accordion-DDp8hUlk.js";
import { u as Z } from "./useNestedProp-BcqToEU0.js";
import { _ as Re } from "./PackageVersion-Ve0s76sL.js";
import { P as De } from "./PenAndPaper-IHG7xTmx.js";
import { resolveComponent as P, openBlock as a, createElementBlock as s, normalizeClass as V, normalizeStyle as L, createBlock as D, createCommentVNode as c, createSlots as Be, withCtx as M, renderSlot as w, normalizeProps as B, guardReactiveProps as H, createVNode as X, createElementVNode as f, Fragment as I, renderList as m, toDisplayString as S, withDirectives as He, vModelCheckbox as Ee, createTextVNode as We } from "vue";
import { _ as Ye } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Xe = J(), qe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ke,
    Shape: pe,
    Title: we,
    Tooltip: Oe,
    UserOptions: ve,
    BaseIcon: ze,
    TableSparkline: Me,
    Skeleton: Te,
    Slicer: Pe,
    Accordion: Ve,
    PackageVersion: Re,
    PenAndPaper: De
  },
  data() {
    this.dataset.forEach((u, t) => {
      [null, void 0].includes(u.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const i = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, l = Math.max(...this.dataset.map((u) => this.largestTriangleThreeBucketsArray({ data: u.series, threshold: i }).length)), o = {
      start: 0,
      end: l
    };
    return {
      themePalettes: K,
      themes: Q,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: l,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Xe,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null,
      showUserOptionsOnChartHover: !1,
      keepUserOptionState: !0,
      userOptionsVisible: !0
    };
  },
  watch: {
    dataset: {
      handler(i, l) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(i, l) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const i = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), l = Math.max(...i.map((t) => t.series.length)), o = [];
      for (let t = 0; t < l; t += 1)
        o.push(i.map((e) => e.series[t] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const u = Math.min(...o);
      return o.map((t) => t + (u < 0 ? Math.abs(u) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const i = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), l = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), u = [...i, ...l, ...o].flatMap((t) => t).length;
      return [...i, ...l, ...o].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / u * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((x) => ({
          y: x >= 0 ? t.zero - t.individualHeight * (x / t.max) : t.zero + t.individualHeight * Math.abs(x) / t.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const i = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(i, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(i) {
        return i;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((i) => i.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((l) => ({
          ...l,
          span: l.from === l.to ? 1 : l.to < l.from ? 0 : l.to - l.from + 1
        }));
      const i = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...i, span: i.from === i.to ? 1 : i.to < i.from ? 0 : i.to - i.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((i, l) => ({
        ...i,
        series: this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${l}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((i, l) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...i,
          series: o.map((u) => this.isSafeValue(u) ? u : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(i.color ? i.color : this.customPalette[l] ? this.customPalette[l] : this.palette[l]),
          id: `uniqueId_${l}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((i, l) => ({
        ...i,
        series: i.series.map((o) => o + this.relativeZero),
        absoluteValues: i.series
      })).filter((i) => !this.segregatedSeries.includes(i.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((i) => {
        const l = i.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: i.id,
          name: i.name,
          color: i.color,
          values: this.fillArray(this.maxSeries, l)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((i, l) => ({
        absoluteIndex: l,
        ...i,
        series: i.series.map((o) => o + this.relativeZero),
        absoluteValues: i.series,
        segregate: () => this.segregate(i),
        isSegregated: this.segregatedSeries.includes(i.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "bar").map((i, l) => {
        this.checkAutoScaleError(i);
        const o = Math.min(...i.absoluteValues.filter((g) => ![null, void 0].includes(g))), u = Math.max(...i.absoluteValues.filter((g) => ![null, void 0].includes(g))), e = {
          ratios: i.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - o) / (u - o)),
          valueMin: o,
          valueMax: u < 0 ? 0 : u
        }, x = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues.filter((g) => ![void 0, null].includes(g))) > 0 ? 0 : Math.min(...i.absoluteValues.filter((g) => ![null, void 0].includes(g)))
        }, A = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, k = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * k : x.max, A), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * k : e.valueMax, A), T = N.min >= 0 ? 0 : Math.abs(N.min), v = 0, p = N.max + T, O = b.max + Math.abs(v), _ = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, z = this.drawingArea.bottom - _ - C * T / p, r = this.drawingArea.bottom - _ - C * v / O, h = this.absoluteDataset.filter((g) => g.type === "bar").filter((g) => !this.segregatedSeries.includes(g.id)).length, n = i.series.map((g, F) => {
          const W = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + T) / p : this.ratioToMax(g), Y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left + this.slot.bar * l + this.slot.bar * F * h - this.barSlot / 2 - l * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(Y),
            y: this.drawingArea.bottom - _ - C * W,
            value: i.absoluteValues[F],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), d = i.absoluteValues.map((g) => b.min >= 0 ? (g - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (g + Math.abs(b.min)) / (b.max + Math.abs(b.min))), E = i.series.map((g, F) => {
          const W = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * l + this.slot.bar * F * this.absoluteDataset.filter((Y) => Y.type === "bar").filter((Y) => !this.segregatedSeries.includes(Y.id)).length;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(W),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(_) - (this.checkNaN(C) * d[F] || 0)),
            value: i.absoluteValues[F],
            zeroPosition: this.checkNaN(z),
            individualMax: this.checkNaN(p),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), y = N.ticks.map((g) => ({
          y: g >= 0 ? z - C * (g / p) : z + C * Math.abs(g) / p,
          value: g,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), G = b.ticks.map((g) => {
          const F = (g - b.min) / (b.max - b.min);
          return {
            y: g >= 0 ? r - C * F : r + C * F,
            value: g,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: _,
          autoScaleYLabels: G,
          individualHeight: C,
          scaleYLabels: i.autoScaling ? G : y,
          individualScale: i.autoScaling ? b : N,
          individualMax: i.autoScaling ? O : p,
          zeroPosition: i.autoScaling ? r : z,
          plots: i.autoScaling ? E : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((i) => !this.segregatedSeries.includes(i.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "line").map((i) => {
        this.checkAutoScaleError(i);
        const l = Math.min(...i.absoluteValues.filter((g) => ![void 0, null].includes(g))), o = Math.max(...i.absoluteValues.filter((g) => ![void 0, null].includes(g))) || 1, t = {
          ratios: i.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || (Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues))
        }, x = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + Math.abs(b), p = N.max + Math.abs(T), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * b / v, z = this.drawingArea.bottom - O - _ * T / p, r = i.series.map((g, F) => {
          const W = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + Math.abs(b)) / v : this.ratioToMax(g);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * W),
            value: i.absoluteValues[F],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), h = i.absoluteValues.map((g) => N.min >= 0 ? (g - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (g + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = i.series.map((g, F) => [void 0, null].includes(i.absoluteValues[F]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: C,
          value: i.absoluteValues[F],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[F] || 0)),
          value: i.absoluteValues[F],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        }), d = this.createSmoothPath(r), E = this.createSmoothPath(n), y = k.ticks.map((g) => ({
          y: g >= 0 ? C - _ * (g / v) : C + _ * Math.abs(g) / v,
          value: g,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), G = N.ticks.map((g) => {
          const F = (g - N.min) / (N.max - N.min);
          return {
            y: g >= 0 ? z - _ * F : z + _ * F,
            value: g,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: O,
          autoScaleYLabels: G,
          individualHeight: _,
          scaleYLabels: i.autoScaling ? G : y,
          individualScale: i.autoScaling ? N : k,
          individualMax: i.autoScaling ? p : v,
          zeroPosition: i.autoScaling ? z : C,
          curve: i.autoScaling ? E : d,
          plots: i.autoScaling ? n : r,
          area: i.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(i.autoScaling ? n : r, i.autoScaling ? z : C) : this.createArea(r) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "plot").map((i) => {
        this.checkAutoScaleError(i);
        const l = Math.min(...i.absoluteValues.filter((y) => ![null, void 0].includes(y))), o = Math.max(...i.absoluteValues.filter((y) => ![null, void 0].includes(y))) || 1, t = {
          ratios: i.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues)
        }, x = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + b, p = N.max + Math.abs(T), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * b / v, z = this.drawingArea.bottom - O - _ * T / p, r = i.series.map((y, G) => {
          const g = this.mutableConfig.useIndividualScale ? (i.absoluteValues[G] + Math.abs(b)) / v : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * g),
            value: i.absoluteValues[G],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
          };
        }), h = i.absoluteValues.map((y) => N.min >= 0 ? (y - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (y + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = i.series.map((y, G) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[G] || 0)),
          value: i.absoluteValues[G],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
        })), d = k.ticks.map((y) => ({
          y: y >= 0 ? C - _ * (y / v) : C + _ * Math.abs(y) / v,
          value: y,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), E = N.ticks.map((y) => {
          const G = (y - N.min) / (N.max - N.min);
          return {
            y: y >= 0 ? z - _ * G : z + _ * G,
            value: y,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: O,
          autoScaleYLabels: E,
          individualHeight: _,
          scaleYLabels: i.autoScaling ? E : d,
          individualScale: i.autoScaling ? N : k,
          individualMax: i.autoScaling ? p : v,
          zeroPosition: i.autoScaling ? z : C,
          plots: i.autoScaling ? n : r
        };
      });
    },
    drawingArea() {
      const i = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((l) => !this.segregatedSeries.includes(l.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + i,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + i)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((i) => !this.segregatedSeries.includes(i.id)).map((i) => Math.max(...i.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const i = Math.min(...this.safeDataset.filter((l) => !this.segregatedSeries.includes(l.id)).map((l) => Math.min(...l.series)));
      return i > 0 ? 0 : i;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const i = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), l = [];
      for (let o = 0; o < i; o += 1)
        l.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return l.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((i) => i.type === "bar").filter((i) => !this.segregatedSeries.includes(i.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const i = this.safeDataset.filter((l) => l.type === "bar").filter((l) => !this.segregatedSeries.includes(l.id)).length;
      return this.drawingArea.width / this.maxSeries / i - this.barPeriodGap * i;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((i) => i !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const i = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), l = [];
      return this.timeLabels.forEach((o, u) => {
        const t = [o.text];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[u]) ? Number(e.absoluteValues[u].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), l.push(t);
      }), { head: i, body: l };
    },
    dataTable() {
      const i = this.FINAL_CONFIG.table.showSum;
      let l = [""].concat(this.relativeDataset.map((e) => e.name));
      i && (l = l.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((A) => A.absoluteValues[e] ?? 0).reduce((A, k) => A + k, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (A) => this.applyDataLabel(
              A.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : A.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              A.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: A.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: A.absoluteValues[e] ?? 0,
                s: A.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(i ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const u = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: l, body: o, config: u, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((i) => ({
        shape: i.shape || null,
        name: i.name,
        color: i.color,
        type: i.type,
        value: i.absoluteValues.find((l, o) => o === this.selectedSerieIndex),
        comments: i.comments || [],
        prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let i = "", l = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], u = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(u) && this.functionReturnsString(() => u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", x = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" />` : t.shape === "triangle" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "square" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "diamond" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "pentagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "hexagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${t.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          i += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / l * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${i}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((i) => ({
        y: i >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(i) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(i)),
        value: i,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (i) => {
      this.clientPosition = {
        x: i.clientX,
        y: i.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ie,
    assignStackRatios: re,
    calcLinearProgression: ae,
    calculateNiceScaleWithExactExtremes: le,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: he,
    convertConfigColors: oe,
    convertCustomPalette: ce,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: U,
    downloadCsv: fe,
    error: Ie,
    functionReturnsString: Ne,
    hasDeepProperty: me,
    isFunction: xe,
    isSafeValue: be,
    largestTriangleThreeBucketsArray: Fe,
    objectIsEmpty: _e,
    setOpacity: Ae,
    shiftHue: ye,
    translateSize: Le,
    treeShake: Ce,
    useMouse: Ge,
    useNestedProp: Z,
    setUserOptionsVisibility(i = !1) {
      this.showUserOptionsOnChartHover && (this.userOptionsVisible = i);
    },
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(i, l) {
      const o = this.relativeDataset.map((u) => ({
        shape: u.shape || null,
        name: u.name,
        color: u.color,
        type: u.type,
        value: u.absoluteValues.find((t, e) => e === l),
        comments: u.comments || [],
        prefix: u.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: u.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: i.absoluteIndex,
        label: i.text
      });
    },
    getHighlightAreaPosition(i) {
      const l = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (i.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span;
      return {
        x: l < this.drawingArea.left ? this.drawingArea.left : l,
        width: o
      };
    },
    prepareConfig() {
      const i = Se().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return i;
      const l = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: i
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? l.chart.highlightArea = this.config.chart.highlightArea : l.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? l.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : l.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? l.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : l.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? l.chart.zoom.startIndex = this.config.chart.zoom.startIndex : l.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? l.chart.zoom.endIndex = this.config.chart.zoom.endIndex : l.chart.zoom.endIndex = null, l.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[l.theme] || this.config,
          defaultConfig: l
        }),
        customPalette: this.themePalettes[l.theme] || this.palette
      } : l;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((i, l) => {
        [null, void 0].includes(i.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: l
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((i) => {
        i.series.forEach((l, o) => {
          this.isSafeValue(l) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${i.name}' contains the value '${l}' at index ${o}.
'${l}' was converted to null to allow the chart to display.`);
        });
      }), this.showUserOptionsOnChartHover = this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.keepUserOptionState = this.FINAL_CONFIG.chart.userOptions.keepStateOnChartLeave, this.userOptionsVisible = !this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const l = this.$refs.chart.parentNode, { height: o, width: u } = l.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let x = null, A = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, A = x.getBoundingClientRect().height);
        let k = null, N = 0;
        this.FINAL_CONFIG.chart.legend.show && (k = this.$refs.chartLegend, N = k.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height);
        let T = 0;
        this.$refs.noTitle && (T = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - N - A - b - T, this.width = u, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((p) => {
          for (const O of p)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (A = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (N = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = O.contentBoxSize[0].blockSize - e - N - A - b - 24, this.width = O.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(l);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(i) {
      this.selectedMinimapIndex = i;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(i) {
      i.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(i) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const l = { x: i[0].x, y: this.zero }, o = { x: i.at(-1).x, y: this.zero }, u = [];
      return i.forEach((t) => {
        u.push(`${t.x},${t.y} `);
      }), [l.x, l.y, ...u, o.x, o.y].toString();
    },
    createIndividualArea(i, l) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const o = { x: i[0] ? i[0].x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: l }, u = { x: i.at(-1) ? i.at(-1).x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: l }, t = [];
      return i.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...t, u.x, u.y].toString();
    },
    createStar: q,
    createPolygonPath: R,
    fillArray(i, l) {
      let o = Array(i).fill(0);
      for (let u = 0; u < l.length && u < i; u += 1)
        o[u] = l[u];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((i) => this.largestTriangleThreeBucketsArray({ data: i.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(i) {
      const l = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return i > l ? l : i < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && i < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : i;
    },
    calcRectHeight(i) {
      return i.value >= 0 ? this.checkNaN(this.zero - i.y <= 0 ? 1e-5 : this.zero - i.y) : this.checkNaN(i.y - this.zero <= 0 ? 1e-5 : i.y - this.zero);
    },
    calcIndividualHeight(i) {
      return i.value >= 0 ? this.checkNaN(i.zeroPosition - i.y <= 0 ? 1e-5 : i.zeroPosition - i.y) : this.checkNaN(i.y - i.zeroPosition <= 0 ? 1e-5 : i.zeroPosition - i.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(i) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? i.x + this.drawingArea.width / this.maxSeries * 0.05 : i.x + this.slot.bar / 2;
    },
    calcRectY(i) {
      return i.value >= 0 ? i.y : this.zero;
    },
    calcIndividualRectY(i) {
      return i.value >= 0 ? i.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(i.zeroPosition) ? 0 : i.zeroPosition;
    },
    canShowValue(i) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(i);
    },
    findClosestValue(i, l) {
      let o = l[0], u = Math.abs(i - l[0]);
      for (let t = 1; t < l.length; t += 1) {
        const e = Math.abs(i - l[t]);
        e < u && l[t] < i && (o = l[t], u = e);
      }
      return o;
    },
    ratioToMax(i) {
      return i / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(i) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((l) => ({
            name: l.name,
            value: [null, void 0, NaN].includes(l.absoluteValues[i]) ? null : l.absoluteValues[i],
            color: l.color,
            type: l.type
          })),
          index: i,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((i) => ({
        values: i.absoluteValues,
        color: i.color,
        name: i.name,
        type: i.type
      }));
    },
    segregate(i) {
      if (this.segregatedSeries.includes(i.id))
        this.segregatedSeries = this.segregatedSeries.filter((l) => l !== i.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(i.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((l) => ({
        name: l.name,
        values: l.absoluteValues,
        color: l.color,
        type: l.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(i, l = null) {
      this.isTooltip = i, i ? this.selectedSerieIndex = l : this.selectedSerieIndex = null;
    },
    toggleFullscreen(i) {
      this.isFullscreen = i, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./pdf-B7oVat64.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (i) {
          console.error("Error generating PDF:", i);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const i = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], l = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, u = i.concat([l]).concat(o), t = this.createCsvContent(u);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./img-DGzWcJ4Y.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (i) {
          console.error("Error generating image:", i);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ue = ["id"], Ze = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, Je = ["viewBox"], Ke = { key: 0 }, Qe = { class: "vue-ui-xy-grid" }, je = ["stroke", "x1", "x2", "y1", "y2"], $e = ["stroke", "x1", "x2", "y1", "y2"], et = { key: 1 }, tt = ["x1", "x2", "y1", "y2", "stroke"], it = ["x1", "x2", "y1", "y2", "stroke"], rt = ["x1", "x2", "y1", "y2", "stroke"], at = { key: 3 }, lt = ["x1", "x2", "y1", "y2", "stroke"], st = ["id"], nt = ["stop-color"], ht = ["stop-color"], ot = ["stop-color"], ct = ["id"], dt = ["stop-color"], ut = ["stop-color"], gt = ["stop-color"], ft = ["id"], It = ["stop-color"], Nt = ["stop-color"], mt = ["id"], xt = ["stop-color"], bt = ["stop-color"], Ft = ["id"], _t = ["stop-color"], At = ["stop-color"], yt = ["x", "y", "height", "width", "fill"], Lt = ["x", "y", "width"], Ct = ["x", "y", "height", "width", "fill"], St = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], kt = ["width", "x", "y"], wt = { key: 0 }, Ot = ["id"], Gt = ["fill"], vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], pt = ["x", "y", "font-size", "fill"], zt = ["stroke", "x1", "x2", "y1", "y2"], Mt = { key: 2 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Pt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Vt = { key: 4 }, Rt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Dt = ["fill", "font-size", "transform"], Bt = ["x1", "x2", "y1", "y2", "stroke"], Ht = ["x", "y", "font-size", "fill"], Et = ["x1", "x2", "y1", "y2", "stroke"], Wt = ["x", "y", "font-size", "fill"], Yt = ["width", "x", "y"], Xt = { style: { width: "100%" } }, qt = { key: 0 }, Ut = ["id"], Zt = ["fill"], Jt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Kt = ["x", "y", "font-size", "fill"], Qt = ["d", "stroke", "stroke-width", "stroke-dasharray"], jt = { key: 1 }, $t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ei = { key: 0 }, ti = ["d", "fill"], ii = ["d", "fill"], ri = ["d", "stroke", "stroke-width", "stroke-dasharray"], ai = { key: 2 }, li = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], si = ["width", "x", "y"], ni = { style: { width: "100%" } }, hi = { key: 3 }, oi = ["id"], ci = ["fill"], di = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ui = ["x", "y", "font-size", "fill"], gi = { key: 5 }, fi = ["x", "y", "font-size", "fill"], Ii = ["x", "y", "font-size", "fill", "font-weight"], Ni = { key: 6 }, mi = ["x", "y", "font-size", "fill"], xi = ["x", "y"], bi = ["x", "y"], Fi = { key: 7 }, _i = ["x", "y", "font-size", "fill"], Ai = ["x", "y"], yi = ["x", "y"], Li = ["x", "y", "font-size", "fill", "innerHTML"], Ci = ["x", "y", "font-size", "fill", "innerHTML"], Si = ["x", "y", "font-size", "fill", "innerHTML"], ki = ["x", "y", "font-size", "fill", "innerHTML"], wi = ["x", "y", "width", "height", "fill", "onMouseenter"], Oi = ["font-size", "fill", "transform"], Gi = ["x", "y", "font-size", "fill"], vi = { key: 9 }, pi = ["text-anchor", "font-size", "fill", "transform", "onClick"], zi = ["x", "y", "height", "width", "onMouseenter", "onClick"], Mi = { key: 10 }, Ti = ["x", "y"], Pi = ["cx", "cy", "r", "fill"], Vi = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ri = ["onClick"], Di = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Bi = ["stroke", "fill"], Hi = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Ei = ["fill"], Wi = {
  key: 9,
  ref: "chartLegend"
}, Yi = {
  key: 10,
  ref: "source",
  dir: "auto"
}, Xi = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, qi = ["innerHTML"];
function Ui(i, l, o, u, t, e) {
  const x = P("PenAndPaper"), A = P("Title"), k = P("UserOptions"), N = P("PackageVersion"), b = P("Shape"), T = P("Skeleton"), v = P("Slicer"), p = P("Tooltip"), O = P("BaseIcon"), _ = P("TableSparkline"), C = P("DataTable"), z = P("Accordion");
  return a(), s("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: V(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`),
    onMouseenter: l[7] || (l[7] = () => e.setUserOptionsVisibility(!0)),
    onMouseleave: l[8] || (l[8] = () => e.setUserOptionsVisibility(!1))
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (a(), D(x, {
      key: 0,
      parent: i.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (a(), s("div", Ze, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (a(), s("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: L(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (a(), D(A, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset && (t.keepUserOptionState || t.userOptionsVisible) ? (a(), D(k, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: i.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator,
      style: L({
        visibility: t.keepUserOptionState ? t.userOptionsVisible ? "visible" : "hidden" : "visible"
      })
    }, Be({ _: 2 }, [
      i.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: M(() => [
          w(i.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      i.$slots.optionPdf ? {
        name: "optionPdf",
        fn: M(() => [
          w(i.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      i.$slots.optionCsv ? {
        name: "optionCsv",
        fn: M(() => [
          w(i.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      i.$slots.optionImg ? {
        name: "optionImg",
        fn: M(() => [
          w(i.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      i.$slots.optionTable ? {
        name: "optionTable",
        fn: M(() => [
          w(i.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      i.$slots.optionLabels ? {
        name: "optionLabels",
        fn: M(() => [
          w(i.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      i.$slots.optionStack ? {
        name: "optionStack",
        fn: M(() => [
          w(i.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      i.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: M(({ toggleFullscreen: r, isFullscreen: h }) => [
          w(i.$slots, "optionFullscreen", B(H({ toggleFullscreen: r, isFullscreen: h })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      i.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: M(({ toggleAnnotator: r, isAnnotator: h }) => [
          w(i.$slots, "optionAnnotator", B(H({ toggleAnnotator: r, isAnnotator: h })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator", "style"])) : c("", !0),
    e.isDataset ? (a(), s("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: V([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: L(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(N),
      e.maxSeries > 0 ? (a(), s("g", Ke, [
        f("g", Qe, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (a(), s("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, je)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(!0), s(I, { key: 2 }, m(e.allScales, (r) => (a(), s("g", null, [
            r.id === t.selectedScale && r.yLabels.length ? (a(!0), s(I, { key: 0 }, m(r.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(h.y),
              y2: e.checkNaN(h.y),
              stroke: r.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, it))), 256)) : r.yLabels.length ? (a(!0), s(I, { key: 1 }, m(r.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(h.y),
              y2: e.checkNaN(h.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, rt))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (a(), s(I, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (a(), s("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, $e)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(), s("g", et, [
              (a(!0), s(I, null, m(e.yLabels, (r) => (a(), s("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(r.y),
                y2: e.checkNaN(r.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, tt))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (a(), s("g", at, [
            (a(!0), s(I, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (r, h) => (a(), s("line", {
              key: `grid_vertical_line_${h}`,
              x1: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, lt))), 128))
          ])) : c("", !0)
        ]),
        (a(!0), s(I, null, m(e.barSet, (r, h) => (a(), s("defs", {
          key: `def_rect_${h}`
        }, [
          f("linearGradient", {
            id: `rectGradient_pos_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": r.color
            }, null, 8, nt),
            f("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, ht),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, ot)
          ], 8, st),
          f("linearGradient", {
            id: `rectGradient_neg_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, dt),
            f("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, ut),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, gt)
          ], 8, ct)
        ]))), 128)),
        (a(!0), s(I, null, m(e.plotSet, (r, h) => (a(), s("defs", {
          key: `def_plot_${h}`
        }, [
          f("radialGradient", {
            id: `plotGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, It),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, Nt)
          ], 8, ft)
        ]))), 128)),
        (a(!0), s(I, null, m(e.lineSet, (r, h) => (a(), s("defs", {
          key: `def_line_${h}`
        }, [
          f("radialGradient", {
            id: `lineGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, xt),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, bt)
          ], 8, mt),
          f("linearGradient", {
            id: `areaGradient_${h}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(r.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, _t),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, At)
          ], 8, Ft)
        ]))), 128)),
        (a(!0), s(I, null, m(e.highlightAreas, (r) => (a(), s("g", null, [
          r.show ? (a(!0), s(I, { key: 0 }, m(r.span, (h, n) => (a(), s("g", null, [
            f("rect", {
              style: L({
                transition: "none",
                opacity: r.from + n >= t.slicer.start && r.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(r.color, r.opacity)
            }, null, 12, yt),
            r.caption.text && n === 0 ? (a(), s("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start) - (r.caption.width === "auto" ? 0 : r.caption.width / 2 - e.drawingArea.width / e.maxSeries * r.span / 2),
              y: e.drawingArea.top + r.caption.offsetY,
              style: L({
                overflow: "visible",
                opacity: r.to >= t.slicer.start && r.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: r.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * r.span : r.caption.width
            }, [
              f("div", {
                style: L(`padding:${r.caption.padding}px;text-align:${r.caption.textAlign};font-size:${r.caption.fontSize}px;color:${r.caption.color};font-weight:${r.caption.bold ? "bold" : "normal"}`)
              }, S(r.caption.text), 5)
            ], 12, Lt)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        f("g", null, [
          (a(!0), s(I, null, m(e.maxSeries, (r, h) => (a(), s("g", {
            key: `tooltip_trap_highlighter_${h}`
          }, [
            f("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(h) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Ct)
          ]))), 128))
        ]),
        e.barSet.length ? (a(!0), s(I, { key: 0 }, m(e.barSet, (r, h) => (a(), s("g", {
          key: `serie_bar_${h}`,
          class: V(`serie_bar_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
            key: `bar_plot_${h}_${d}`
          }, [
            e.canShowValue(n.value) ? (a(), s("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${h}_${t.uniqueId})` : `url(#rectGradient_neg_${h}_${t.uniqueId})` : r.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, St)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              w(i.$slots, "plot-comment", {
                plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
              }, void 0, !0)
            ], 8, kt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", wt, [
            f("defs", null, [
              f("marker", {
                id: `bar_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Gt)
              ], 8, Ot)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.calcLinearProgression(r.plots).y1,
              y2: e.calcLinearProgression(r.plots).y2,
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${h})`
            }, null, 8, vt)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, pt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (a(), s("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, zt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Mt, [
          f("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Tt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (a(), s("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Pt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (a(), s("g", Vt, [
          t.mutableConfig.useIndividualScale ? (a(), s(I, { key: 0 }, [
            (a(!0), s(I, null, m(e.allScales, (r) => (a(), s("g", null, [
              f("line", {
                x1: r.x + e.xPadding,
                x2: r.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - r.yOffset - r.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - r.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Rt)
            ]))), 256)),
            (a(!0), s(I, null, m(e.allScales, (r) => (a(), s("g", {
              style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              f("text", {
                fill: r.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset - r.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(r.name) + " " + S(r.scaleLabel ? `- ${r.scaleLabel}` : ""), 9, Dt),
              (a(!0), s(I, null, m(r.yLabels, (h, n) => (a(), s("line", {
                x1: r.x - 3 + e.xPadding,
                x2: r.x + e.xPadding,
                y1: e.checkNaN(h.y),
                y2: e.checkNaN(h.y),
                stroke: r.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Bt))), 256)),
              (a(!0), s(I, null, m(r.yLabels, (h, n) => (a(), s("text", {
                x: r.x - 5 + e.xPadding,
                y: e.checkNaN(h.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: r.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                h.value,
                e.dataLabel({
                  p: h.prefix,
                  v: h.value,
                  s: h.suffix,
                  r: 1
                }),
                { datapoint: h.datapoint, seriesIndex: n }
              )), 9, Ht))), 256))
            ], 4))), 256))
          ], 64)) : (a(!0), s(I, { key: 1 }, m(e.yLabels, (r, h) => (a(), s("g", {
            key: `yLabel_${h}`
          }, [
            e.canShowValue(r) && r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (a(), s("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(r.y),
              y2: e.checkNaN(r.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Et)) : c("", !0),
            r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (a(), s("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(r.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(r.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              r.value,
              e.dataLabel({
                p: r.prefix,
                v: r.value,
                s: r.suffix,
                r: 1
              })
            ) : ""), 9, Wt)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (a(!0), s(I, null, m(e.plotSet, (r, h) => (a(), s("g", {
          key: `serie_plot_${h}`,
          class: V(`serie_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
            key: `circle_plot_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (a(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? r.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", Xt, [
                w(i.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, Yt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", qt, [
            f("defs", null, [
              f("marker", {
                id: `plot_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Zt)
              ], 8, Ut)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.calcLinearProgression(r.plots).y1,
              y2: e.calcLinearProgression(r.plots).y2,
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${h})`
            }, null, 8, Jt)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Kt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (a(!0), s(I, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: V(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.smooth && r.plots.length > 1 ? (a(), s("path", {
            key: 0,
            d: `M${r.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Qt)) : r.plots.length > 1 ? (a(), s("g", jt, [
            (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < r.plots.length - 1 && r.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(r.plots[d + 1].value) ? (a(), s("line", {
                key: 0,
                x1: n.x,
                x2: r.plots[d + 1].x,
                y1: n.y,
                y2: r.plots[d + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, $t)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        (a(!0), s(I, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: V(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.useArea && r.plots.length > 1 ? (a(), s("g", ei, [
            r.smooth ? (a(), s("path", {
              key: 0,
              d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ti)) : (a(), s("path", {
              key: 1,
              d: `M${r.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ii))
          ])) : c("", !0),
          r.smooth && r.plots.length > 1 ? (a(), s("path", {
            key: 1,
            d: `M${r.curve}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ri)) : r.plots.length > 1 ? (a(), s("g", ai, [
            (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < r.plots.length - 1 && r.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(r.plots[d + 1].value) ? (a(), s("line", {
                key: 0,
                x1: n.x,
                x2: r.plots[d + 1].x,
                y1: n.y,
                y2: r.plots[d + 1].y,
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, li)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
            key: `circle_line_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (a(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? r.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", ni, [
                w(i.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, si)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", hi, [
            f("defs", null, [
              f("marker", {
                id: `line_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, ci)
              ], 8, oi)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.calcLinearProgression(r.plots).y1,
              y2: e.calcLinearProgression(r.plots).y2,
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${h})`
            }, null, 8, di)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ui)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (a(), s("g", gi, [
          (a(!0), s(I, null, m(e.barSet, (r, h) => (a(), s("g", {
            key: `xLabel_bar_${h}`,
            class: V(`xLabel_bar_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
              key: `xLabel_bar_${h}_${d}`
            }, [
              n && (!Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d) && e.FINAL_CONFIG.bar.labels.show ? (a(), s("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, fi)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (a(), s("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? r.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: r.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : r.name), 9, Ii)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", Ni, [
          (a(!0), s(I, null, m(e.plotSet, (r, h) => (a(), s("g", {
            key: `xLabel_plot_${h}`,
            class: V(`xLabel_plot_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
              key: `xLabel_plot_${h}_${d}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, mi)) : c("", !0),
              n && d === 0 && r.useTag && r.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(r.name), 5)
              ], 8, xi)) : c("", !0),
              n && d === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(r.name), 5)
              ], 8, bi)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", Fi, [
          (a(!0), s(I, null, m(e.lineSet, (r, h) => (a(), s("g", {
            key: `xLabel_line_${h}`,
            class: V(`xLabel_line_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
              key: `xLabel_line_${h}_${d}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, _i)) : c("", !0),
              n && d === 0 && r.useTag && r.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(r.name), 5)
              ], 8, Ai)) : c("", !0),
              n && d === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(r.name), 5)
              ], 8, yi)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (a(!0), s(I, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `xLabel_line_${h}`,
          class: V(`xLabel_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
            key: `xLabel_line_${h}_${d}`
          }, [
            n && d === 0 && r.showSerieName && r.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Li)) : c("", !0),
            n && d === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ci)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (a(!0), s(I, null, m(e.plotSet, (r, h) => (a(), s("g", {
          key: `xLabel_plot_${h}`,
          class: V(`xLabel_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(I, null, m(r.plots, (n, d) => (a(), s("g", {
            key: `xLabel_plot_${h}_${d}`
          }, [
            n && d === 0 && r.showSerieName && r.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Si)) : c("", !0),
            n && d === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ki)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (a(!0), s(I, { key: 8 }, m(e.allScales, (r) => (a(), s("rect", {
          x: r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === r.id ? e.setOpacity(r.color, 20) : "transparent",
          onMouseenter: (h) => t.selectedScale = r.id,
          onMouseleave: l[0] || (l[0] = (h) => t.selectedScale = null)
        }, null, 40, wi))), 256)) : c("", !0),
        f("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (a(), s("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Oi)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (a(), s("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Gi)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (a(), s("g", vi, [
          i.$slots["time-label"] ? (a(!0), s(I, { key: 0 }, m(e.timeLabels, (r, h) => (a(), s("g", {
            key: `time_label_${h}`
          }, [
            w(i.$slots, "time-label", B(H({
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2,
              y: e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
              fontSize: t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              absoluteIndex: r.absoluteIndex,
              content: r.text,
              textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              show: r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
            })), void 0, !0)
          ]))), 128)) : (a(!0), s(I, { key: 1 }, m(e.timeLabels, (r, h) => (a(), s("g", {
            key: `time_label_${h}`
          }, [
            r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (a(), s("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(r, h)
            }, S(r.text || ""), 9, pi)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        f("g", null, [
          (a(!0), s(I, null, m(e.maxSeries, (r, h) => (a(), s("g", {
            key: `tooltip_trap_${h}`
          }, [
            f("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, h),
              onMouseleave: l[1] || (l[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(h)
            }, null, 40, zi)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Mi, [
          (a(), s("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            f("div", {
              class: "vue-ui-xy-time-tag",
              style: L(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)].text || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Ti)),
          f("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Pi)
        ])) : c("", !0)
      ])) : c("", !0),
      w(i.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Je)) : c("", !0),
    i.$slots.watermark ? (a(), s("div", Vi, [
      w(i.$slots, "watermark", B(H({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (a(), D(T, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (a(), D(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": l[2] || (l[2] = (r) => t.slicer.start = r),
      end: t.slicer.end,
      "onUpdate:end": l[3] || (l[3] = (r) => t.slicer.end = r),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((r) => e.largestTriangleThreeBucketsArray({ data: r.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": M(({ reset: r }) => [
        w(i.$slots, "reset-action", B(H({ reset: r })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (a(), s("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: L(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (a(!0), s(I, null, m(e.absoluteDataset, (r, h) => (a(), s("div", {
        key: `div_legend_item_${h}`,
        onClick: (n) => e.segregate(r),
        class: V({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(r.id) })
      }, [
        t.icons[r.type] === "line" ? (a(), s("svg", Di, [
          f("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: r.color
          }, null, 8, Bi),
          X(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (a(), s("svg", Hi, [
          t.icons[r.type] === "bar" ? (a(), s("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: r.color
          }, null, 8, Ei)) : (a(), D(b, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        f("span", {
          style: L(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(r.name), 5)
      ], 10, Ri))), 128))
    ], 4)) : (a(), s("div", Wi, [
      w(i.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    i.$slots.source ? (a(), s("div", Yi, [
      w(i.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    X(p, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: i.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: t.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": M(() => [
        w(i.$slots, "tooltip-before", B(H({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": M(() => [
        w(i.$slots, "tooltip-after", B(H({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (a(), D(z, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: M(() => [
        f("div", {
          style: L(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          f("div", Xi, [
            He(f("input", {
              type: "checkbox",
              "onUpdate:modelValue": l[4] || (l[4] = (r) => t.showSparklineTable = r)
            }, null, 512), [
              [Ee, t.showSparklineTable]
            ]),
            f("div", {
              onClick: l[5] || (l[5] = (r) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(O, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (a(), D(_, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (a(), D(C, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: l[6] || (l[6] = (r) => t.mutableConfig.showTable = !1)
          }, {
            th: M(({ th: r }) => [
              f("div", { innerHTML: r }, null, 8, qi)
            ]),
            td: M(({ td: r }) => [
              We(S(isNaN(Number(r)) ? r : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: r,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 46, Ue);
}
const cr = /* @__PURE__ */ Ye(qe, [["render", Ui], ["__scopeId", "data-v-70d7bcaa"]]);
export {
  cr as default
};
